'  2008 Michele Leroux Bustamante. All rights reserved 
' Book: Learning WCF, O'Reilly
' Book Blog: www.thatindigogirl.com
' Michele's Blog: www.dasblonde.net
' IDesign: www.idesign.net

Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.Text
Imports System.IdentityModel.Policy
Imports WCFClaims = System.IdentityModel.Claims
Imports Microsoft.IdentityModel.Claims
Imports System.Threading
Imports System.Diagnostics
Imports System.Security.Permissions

Namespace Services
	<ServiceBehavior(InstanceContextMode := InstanceContextMode.PerCall, UseSynchronizationContext:=False)> _
	Public Class CrudService
		Implements ICrudService
		#Region "ICrudService Members"

		<PrincipalPermission(SecurityAction.Demand, Role := Constants.Permissions.Create)> _
		Public Function CreateSomething() As String Implements ICrudService.CreateSomething
			Return "CreateSomething() called"
		End Function

		<PrincipalPermission(SecurityAction.Demand, Role := Constants.Permissions.Read)> _
		Public Function ReadSomething() As String Implements ICrudService.ReadSomething
			Return "ReadSomething() called"
		End Function

		<PrincipalPermission(SecurityAction.Demand, Role := Constants.Permissions.Update)> _
		Public Function UpdateSomething() As String Implements ICrudService.UpdateSomething
			Return "UpdateSomething() called"
		End Function

		<PrincipalPermission(SecurityAction.Demand, Role:=Constants.Permissions.Delete)> _
		Public Function DeleteSomething() As String Implements ICrudService.DeleteSomething
			Return "DeleteSomething() called"
		End Function

		#End Region
	End Class
End Namespace
