'  2008 Michele Leroux Bustamante. All rights reserved 
' Book: Learning WCF, O'Reilly
' Book Blog: www.thatindigogirl.com
' Michele's Blog: www.dasblonde.net
' IDesign: www.idesign.net

Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.ServiceModel
Imports Microsoft.IdentityModel.Tokens

Namespace Services
	Public Class FederatedServiceHost
		Inherits ServiceHost

		Public Sub New(ByVal singletonInstance As Object, ParamArray ByVal baseAddresses() As Uri)
			MyBase.New(singletonInstance, baseAddresses)
		End Sub

		Public Sub New(ByVal serviceType As Type, ParamArray ByVal baseAddresses() As Uri)
			MyBase.New(serviceType, baseAddresses)
		End Sub

		Protected Overrides Sub OnOpening()
			FederatedServiceCredentials.ConfigureServiceHost(Me)
			MyBase.OnOpening()
		End Sub

	End Class
End Namespace
