'  2008 Michele Leroux Bustamante. All rights reserved 
' Book: Learning WCF, O'Reilly
' Book Blog: www.thatindigogirl.com
' Michele's Blog: www.dasblonde.net
' IDesign: www.idesign.net

Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.ServiceModel.Activation

Namespace Services
	Public Class FederatedServiceHostFactory
		Inherits ServiceHostFactory
		Public Sub New()
		End Sub

		Public Overrides Overloads Function CreateServiceHost(ByVal constructorString As String, ByVal baseAddresses() As Uri) As System.ServiceModel.ServiceHostBase
			Dim t As Type = Type.GetType(String.Format("{0}, {1}", constructorString, constructorString.Substring(0, constructorString.IndexOf("."))))
			Return New FederatedServiceHost(t, baseAddresses)
		End Function

		Protected Overrides Overloads Function CreateServiceHost(ByVal serviceType As Type, ByVal baseAddresses() As Uri) As System.ServiceModel.ServiceHost
			Return New FederatedServiceHost(serviceType, baseAddresses)
		End Function

	End Class
End Namespace
