'  2008 Michele Leroux Bustamante. All rights reserved 
' Book: Learning WCF, O'Reilly
' Book Blog: www.thatindigogirl.com
' Michele's Blog: www.dasblonde.net
' IDesign: www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.IdentityModel.Tokens
Imports Microsoft.IdentityModel.Tokens


Namespace Services
	Public Class TrustedIssuerNameRegistry
		Inherits IssuerNameRegistry
		Public Overrides Function GetIssuerName(ByVal securityToken As SecurityToken) As String
			Dim x509Token As X509SecurityToken = TryCast(securityToken, X509SecurityToken)
			If x509Token IsNot Nothing Then
				If String.Equals(x509Token.Certificate.SubjectName.Name, "CN=IPKey") Then
					Return x509Token.Certificate.SubjectName.Name
				End If
			End If

			Throw New SecurityTokenException("Untrusted issuer.")
		End Function
	End Class
End Namespace
